//
// 2008.08 Kyoung Shin Park 
//
#ifndef __WIN32_SHM_H__
#define __WIN32_SHM_H__

#include <string>

#ifndef key_t
typedef int key_t;
#endif

#define   IPC_PRIVATE     (key_t) 0  
#define   IPC_CREAT       0001000 
#define   IPC_EXCL        0002000         /* fail if key exists */
#define   IPC_RMID        10			  /* remove identifier */
#define	  S_IRUSR			1
#define	  S_IWUSR			2

using namespace std;

class CSharedMemory  
{
public:
	CSharedMemory(string name);
	void createMutex();
	void openMutex();
	void lockMutex();
	void unlockMutex();
	void closeMutex();
	HANDLE getShm(key_t key, size_t size, int shmflg);
	int cleanShm(HANDLE shmid, int cmd, struct shmid_ds *buf); 
	void * attachShm(HANDLE shmid, const void *shmaddr, int shmflg);
	int detachShm(const void *shmaddr); 

private:
	string m_Name;
	string m_MemoryName;
	string m_MutexName;
	HANDLE m_hKeyMutex;
	HANDLE m_hMemory;
	//int m_KeyValue;
};


#endif